[tox]
envlist = pylint,flake8,pydocstyle,typing,black,cov-init,py312,cov-report
skip_missing_interpreters = True

[testenv:pylint]
basepython = {env:PYTHON3_PATH:python3}
ignore_errors = True
deps =
    -r {toxinidir}{/}test_requirements.txt
commands =
    pylint --rcfile=.pylintrc mqtt_hass_base tests
    pyreverse -o png -o mmd -o html mqtt_hass_base tests

[testenv:flake8]
basepython = {env:PYTHON3_PATH:python3}
deps =
    -r {toxinidir}{/}test_requirements.txt
commands =
    flake8 --max-line-length=100 mqtt_hass_base tests

[testenv:pydocstyle]
basepython = {env:PYTHON3_PATH:python3}
deps =
    -r {toxinidir}{/}test_requirements.txt
commands =
    pydocstyle mqtt_hass_base tests

[testenv:typing]
basepython = {env:PYTHON3_PATH:python3}
deps =
    -r {toxinidir}{/}test_requirements.txt
commands =
    python -c "import os; os.remove('.tox/typing/lib/python3.11/site-packages/homeassistant-stubs/components/bluetooth/models.pyi') if os.path.exists('.tox/typing/lib/python3.11/site-packages/homeassistant-stubs/components/bluetooth/models.pyi') else print('ok')"
    mypy --txt-report mypy-txt-report --html-report mypy-html-report --junit-xml mypy-junit.xml --strict --pretty --show-error-codes mqtt_hass_base

[testenv:black]
basepython = {env:PYTHON3_PATH:python3}
deps =
    -r {toxinidir}{/}test_requirements.txt
commands =
    black --check --diff mqtt_hass_base tests

[testenv:cov-init]
setenv =
    COVERAGE_FILE = .coverage
deps = coverage
commands =
    coverage erase

[testenv]
usedevelop=True
setenv =
    COVERAGE_FILE = .coverage

install_command = {envpython} -m pip install {opts} {packages}
commands =
    pytest -vvv --junitxml=tests_result_junit.xml --cov --cov-report= {posargs} tests --asyncio-mode=strict
deps =
    -r {toxinidir}{/}test_requirements.txt

[testenv:cov-combine]
setenv =
    COVERAGE_FILE = .coverage
deps = coverage
commands =
    coverage combine

[testenv:cov-report]
setenv =
    COVERAGE_FILE = .coverage
deps = coverage
commands =
    coverage report --include=mqtt_hass_base/*
    coverage html --include=mqtt_hass_base/*
    coverage xml --include=mqtt_hass_base/*
